# STM32H7S78-DK Discovery board

## Overview

The STM32H7S78-DK Discovery kit is a complete demonstration and development platform for the Arm® Cortex®-M7 core-based STM32H7S7L8H6H microcontroller.

The STM32H7S78-DK Discovery kit includes a full range of hardware features that helps the user to evaluate many peripherals, such as USB Type-C®, Octo-SPI flash memory and Hexadeca-SPI PSRAM devices, audio codec, digital microphones, ADC, flexible extension connectors, and user button. The four flexible extension connectors allow easy and unlimited expansion capabilities for specific applications such as wireless connectivity, analog applications, and sensors.

The STM32H7S7L8H6H microcontroller features three I2C buses, six SPI ports, three USART ports, two SDMMC ports, two CAN ports, an Ethernet port, two SAI ports, two 12-bit ADCs, an embedded step-down converter, two Octo-SPI memory interfaces, one Hexadeca-SPI interface, USB OTG HS port with power delivery, LCD-TFT controller, flexible memory controller (FMC), 8- to 14-bit DCMI interface, JTAG, and SWD debugging support.

The STM32H7S78-DK Discovery kit integrates an STLINK-V3EC embedded in-circuit debugger and programmer for the STM32 MCU, with a USB Virtual COM port bridge and comes with the comprehensive MCU Package.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um3289-discovery-kit-with-stm32h7s7l8-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32H7S7L8 microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32h7s7l8.html)
- [STM32H7S78-DK board](https://www.st.com/en/evaluation-tools/stm32h7s78-dk.html)
- [User manual](https://www.st.com/resource/en/user_manual/um3289-discovery-kit-with-stm32h7s7l8-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32h7s78-dk.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1736-h7s7l8-d01-schematic.pdf)
